<?xml version="1.0" encoding="UTF-8"?>
<!--Multiple camera strategy config table-->
<MultiCameraConfigTable>

<!-- macro distance begin -->
    <rule name = "ZOOM[0.99 - 1.01) Entering macro pre dual stream">
        <condition name = "ZOOM_RATIO" min = "0.99" max = "1.01"/>
        <condition name = "MACRO_MODE" value = "1"/>
        <outState>
            <camera name = "wide" prev = "true" stage = "binning10"/>
            <camera name = "ultra_wide" stage = "binning10"/>
        </outState>
    </rule>

    <rule name = "ZOOM[0.99 - 1.01) Exiting macro pre dual stream">
        <condition name = "ZOOM_RATIO" min = "0.99" max = "1.01"/>
        <condition name = "MACRO_MODE" value = "2"/>
        <outState>
            <camera name = "ultra_wide" prev = "true" stage = "binning10"/>
            <camera name = "wide" stage = "binning10"/>
        </outState>
    </rule>

    <rule name = "ZOOM[0.99 - 1.01) In macro dual stream for vcm">
        <condition name = "ZOOM_RATIO" min = "0.99" max = "1.01"/>
        <condition name = "MACRO_MODE" value = "3"/>
        <outState>
            <camera name = "ultra_wide" prev = "true" stage = "binning10"/>
            <camera name = "wide" stage = "binning10"/>
        </outState>
    </rule>

    <rule name = "ZOOM[0.99 - 1.01) macro stop dual stream">
        <condition name = "ZOOM_RATIO" min = "0.99" max = "1.01"/>
        <condition name = "MACRO_MODE" value = "4"/>
        <outState>
            <camera name = "ultra_wide" prev = "true" stage = "binning10"/>
        </outState>
    </rule>
<!-- macro distance end -->

<!-- zoom ratio begin -->
    <rule name = "[0.1-0.7x default] --> [ultra_wide binning]">
        <condition name = "ZOOM_RATIO" min = "0.1" max = "0.7"/>
        <outState>
            <camera name = "ultra_wide" prev = "true" stage = "binning"/>
        </outState>
    </rule>

    <rule name = "[0.7-1.0x zooming] --> [ultra_wide binning(pre) + wide binning]">
        <condition name = "ZOOM_RATIO" min = "0.7" max = "1.0"/>
        <outState>
            <camera name = "ultra_wide" prev = "true" stage = "binning"/>
            <camera name = "wide" stage = "binning"/>
        </outState>

        <rule name = "[0.7-1.0x no zoom] --> [ultra_wide binning]">
            <condition name = "ZOOM_STATUS" value = "1"/>
            <outState>
                <camera name = "ultra_wide" prev = "true" stage = "binning"/>
            </outState>
        </rule>
    </rule>

    <rule name = "[1.0-2.0x default] --> [wide binning]">
        <condition name = "ZOOM_RATIO" min = "1.0" max = "1.8"/>
        <outState>
            <camera name = "wide" prev = "true" stage = "binning"/>
        </outState>
    </rule>

    <rule name = "[1.8-2.0x zooming] --> [wide binning(pre) + tele binning]">
        <condition name = "ZOOM_RATIO" min = "1.8" max = "2.0"/>
        <outState>
            <camera name = "wide" prev = "true" stage = "binning"/>
            <camera name = "tele" stage = "binning"/>
        </outState>

        <rule name = "[1.8-2.0x no zoom] --> [wide binning]">
            <condition name = "ZOOM_STATUS" value = "1"/>
            <outState>
                <camera name = "wide" prev = "true" stage = "binning"/>
            </outState>
        </rule>
    </rule>

    <rule name = "ZOOM[2.0-2.5x zooming] --> [wide binning(pre) + tele bining]">
        <condition name = "ZOOM_RATIO" min = "2.0" max = "2.5"/>
        <outState>
            <camera name = "wide" prev = "true" stage = "binning"/>
            <camera name = "tele" stage = "binning"/>
        </outState>

        <rule name = "[2.0-2.5x no zoom] --> [wide binning]">
            <condition name = "ZOOM_STATUS" value = "1"/>
            <outState>
                <camera name = "wide" prev = "true" stage = "binning"/>
            </outState>
        </rule>
    </rule>

    <rule name = "ZOOM[2.5-5x) unexpected, check manually">
        <condition name = "ZOOM_RATIO" min = "2.5" max = "5.1"/>
        <outState>
            <camera name = "tele" prev = "true" stage = "binning"/>
        </outState>

        <rule name = "[2.5x-5x, Slightly bright(Non Dark Night)] --> [tele binning]">
            <condition name = "META" tag = "MULTICAM_IS_DARK_NIGHT" type = "INT32" value = "0" outTag = "MULTICAM_CONDITION_DARK_NIGHT"/>
            <outState>
                <camera name = "tele" prev = "true" stage = "binning"/>
            </outState>
        </rule>

        <rule name = "[2.5x-5x, Dark night] --> [wide binning]">
            <condition name = "META" tag = "MULTICAM_IS_DARK_NIGHT" type = "INT32" value = "1" outTag = "MULTICAM_CONDITION_DARK_NIGHT"/>
            <outState>
                <camera name = "wide" prev = "true" stage = "binning"/>
            </outState>
        </rule>

    </rule>

<!-- zoom ratio end -->
    <!-- for output metadata only -->
    <rule name = "ZOOM[10000x] never go in ">
        <condition name = "ZOOM_RATIO" min = "10000" max = "10000.1"/>
        <condition name = "META" tag = "MULTICAM_IS_NIGHT" type = "INT32" value = "0" outTag = "MULTICAM_CONDITION_NIGHT"/>
        <condition name = "META" tag = "MULTICAM_IS_SUPER_NIGHT" type = "INT32" value = "0" outTag = "MULTICAM_CONDITION_SUPER_NIGHT"/>
        <condition name = "META" tag = "MULTICAM_IS_DARK_NIGHT" type = "INT32" value = "0" outTag = "MULTICAM_CONDITION_DARK_NIGHT"/>
        <condition name = "META" tag = "MULTICAM_IS_DARK_NIGHT_LEVEL2" type = "INT32" value = "0" outTag = "MULTICAM_CONDITION_DARK_NIGHT_LEVEL2"/>
        <outState>
            <camera name = "wide" prev = "true"  stage = "binning" />
        </outState>
    </rule>

</MultiCameraConfigTable>
